import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_repository/life_repository.dart';
import 'package:common_module/utils/date_time_helper.dart';

class AppraiseItem extends StatelessWidget {
  final ShopCommentItemEntity item;
  AppraiseItem(this.item);
  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.only(
          top: 16.rpx, bottom: 20.rpx, left: 12.rpx, right: 12.rpx),
      color: Colors.white,
      child: Column(
        children: [
          Container(
            child: Text(
              item.comment!,
              style: TextStyle(color: rgba(48, 38, 0, 1), fontSize: 13.rpx),
            ),
          ),
          SizedBox(
            height: 6.rpx,
          ),
          _ScoreInfo(item),
        ],
      ),
    );
  }
}

/// 评分和距离信息
class _ScoreInfo extends StatelessWidget {
  final ShopCommentItemEntity item;
  _ScoreInfo(this.item);
  @override
  Widget build(BuildContext context) {
    List<InlineSpan> widgets = [];
    double score = double.parse(item.star!);
    for (int star = 1, len = score.ceil(); star <= len; star++) {
      widgets.add(WidgetSpan(
          child: Image.asset(
        star <= score
            ? "assets/ic_star_small_full.png"
            : "assets/ic_star_small_half.png",
        width: 12.rpx,
        height: 12.rpx,
      )));
    }
    for (int star = widgets.length; star < 5; star++) {
      widgets.add(WidgetSpan(
          child: Image.asset(
        "assets/ic_star_small_blank.png",
        width: 12.rpx,
        height: 12.rpx,
      )));
    }

    widgets.add(WidgetSpan(
        child: SizedBox(
      width: 2.rpx,
    )));
    return Container(
      height: 18.rpx,
      child: Row(
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          Container(
            alignment: Alignment.centerLeft,
            height: 14.rpx,
            child: Text.rich(TextSpan(children: widgets)),
          ),
          Container(
            child: Text(double.parse(item.star!).toStringAsFixed(1),
                style: TextStyle(
                  color: rgba(255, 128, 0, 1),
                  fontSize: 14.rpx,
                  fontWeight: FontWeight.bold,
                )),
          ),
          Spacer(),
          Text(
            DateUtil.formatDateStr(item.createTime!,format: "yyyy-MM-dd HH:mm:ss"),
            style: TextStyle(color: rgba(153, 153, 153, 1), fontSize: 11.rpx),
          )
        ],
      ),
    );
  }
}
