import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:navigation_bar/navigation_bar.dart';
import 'package:mvp/mvp.dart';
import 'package:life_module/models/filter_model.dart';
import 'package:life_repository/life_repository.dart';

class ShopClassNav extends StatefulWidget {
  final FilterModel? model;
  final Function()? onChange;
  ShopClassNav({this.model, this.onChange});
  @override
  State<StatefulWidget> createState() => _ShopClassNavState();
}

class _ShopClassNavState extends State<ShopClassNav>
    with TickerProviderStateMixin {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return QMProvider<FilterModel>.value(
        model: widget.model!,
        builderWidget: (context, model, child) {
          if (model.isEmpty()) {
            return Container(
              height: 40.rpx,
            );
          }
          List<FilterItemEntity> subs = model.getCheckedOneCategory()!.subs!;

          return Container(
            key: ValueKey(subs.map((e) => e.id).join('_')),
            height: 40.rpx,
            color: rgba(245, 245, 245, 1),
            transform: Matrix4.translationValues(0, -1.5, 0),
            child: NotificationListener(
              child: NavigationBar(
                controller: model.getShopClassNavTabController(),
                items: subs.map((e) => e.name).toList() as List<String>?,
                selectColor: rgba(255, 128, 0, 1),
                normalColor: rgba(102, 102, 102, 1),
                selectStyle: TextStyle(
                    fontSize: 13.rpx, height: 1, fontWeight: FontWeight.bold),
                normalStyle: TextStyle(
                  fontSize: 13.rpx,
                  height: 1,
                ),
                isScrollable: true,
                onChange: (index) {
                  if (subs[index!] == model.getCheckedTwoCategory()) {
                    return;
                  }
                  model.setCheckedCategory(
                      model.getCheckedOneCategory(), subs[index]);
                  widget.onChange!();
                },
                indicatorSize: TabBarIndicatorSize.label,
                indicator: RoundRectIndicator(
                    color: Colors.transparent, height: 0, marginBottom: 0),
              ),
              onNotification: (dynamic e) {
                return true;
              },
            ),
          );
        });
  }
}
