import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:navigation_bar/navigation_bar.dart';
import 'package:life_module/models/filter_model.dart';
import 'package:mvp/mvp.dart';

class ShopTypeNav extends StatelessWidget {
  final FilterModel? model;
  final Function()? onChange;
  ShopTypeNav({this.model, this.onChange});
  @override
  Widget build(BuildContext context) {
    return QMProvider<FilterModel>.value(
      model: model!,
      builderWidget: (context, model, child) {
        if (model.isEmpty()) {
          return Container(
            height: 37.rpx,
          );
        }
        return Container(
          height: 37.rpx,
          alignment: Alignment.topLeft,
          padding: EdgeInsets.only(top: 12.rpx),
          color: rgba(245, 245, 245, 1),
          child: DefaultTabController(
            length: 2,
            initialIndex: model.getShopTypeNavIndex()!,
            child: NavigationBar(
              items: ["优惠店铺", "优惠套餐"],
              selectColor: rgba(48, 38, 0, 1),
              normalColor: rgba(48, 38, 0, 1),
              selectStyle: TextStyle(
                  fontWeight: FontWeight.bold, fontSize: 18.rpx, height: 1),
              normalStyle: TextStyle(
                fontWeight: FontWeight.bold,
                fontSize: 14.rpx,
                height: 1,
              ),
              isScrollable: true,
              indicatorSize: TabBarIndicatorSize.label,
              indicator: RoundRectIndicator(
                  round: 3.rpx,
                  color: rgba(255, 61, 0, 1),
                  height: 3.rpx,
                  marginBottom: 6.rpx),
              onChange: (index) {
                model.setShopTypeNavIndex(index);
                onChange!();
              },
            ),
          ),
        );
      },
    );
  }
}
