import 'package:mvp/mvp.dart';
import 'package:life_repository/life_repository.dart';

class ShopListModel extends BaseListModel<ShopItemEntity> {
  String? _cityId;
  String? _lat;
  String? _lng;
  String? _firstCateId;
  String _keywords = '';
  late String _secondCateId;
  String? _regionId;
  String? _sortType;
  // 0 优惠店铺,1 优惠套餐
  int? _shopTypeNavIndex = 0;

  @override
  Future<List<ShopItemEntity>> request() {
    return _find();
  }

  Future<List<ShopItemEntity>> _find() {
    if (_shopTypeNavIndex == 0) {
      return ShopListRepository.get().findRestaurantList(
          _cityId!,
          _lat!,
          _lng!,
          getPage().toString(),
          _firstCateId!,
          _keywords,
          _secondCateId,
          _regionId!,
          _sortType!);
    }
    return ShopListRepository.get().findComboList(
        _cityId!,
        _lat!,
        _lng!,
        getPage().toString(),
        _firstCateId!,
        _keywords,
        _secondCateId,
        _regionId!,
        _sortType!);
  }

  void setCityId(String? cid) {
    _cityId = cid;
  }

  void setLat(String? lat) {
    _lat = lat;
  }

  void setLng(String? lng) {
    _lng = lng;
  }

  void setFirstCateId(String? firstCateId) {
    _firstCateId = firstCateId;
  }

  String getKeywords() {
    return _keywords;
  }

  void setKeywords(String keywords) {
    _keywords = keywords;
  }

  void setSecondCateId(String secondCateId) {
    _secondCateId = secondCateId;
  }

  void setRegionId(String? regionId) {
    _regionId = regionId;
  }

  void setSortType(String? sortType) {
    _sortType = sortType;
  }

  void setShopTypeNavIndex(int? index) {
    _shopTypeNavIndex = index;
  }
}
