import 'package:common_module/utils/amap_utils.dart';
import 'package:life_repository/repository/amap_repository.dart';

class Res {
  ///
  /// 历史定位缓存信息key值
  ///
  static String historyLocation = '_history_locations';

  ///
  /// 高德地图Key
  ///
  static String aWebMapKey = '9897a29ccc4b396fc7dc560c50973fae';
  static String aAndroidMapKey = '565eee69e48dbbfe1eb408da0fc31256';
  static String aIOSMapKey = 'e492fb8617d0e93332fe980a934778b0';

  ///
  /// 城市数据
  ///
  static String chinaCityData = 'packages/life_module/assets/data/china.json';

  ///
  /// 城市的历史定位信息
  ///
  static String cityHistoryLocation = 'city/history/location';

  static String icArrowGray =
      'packages/price_module/assets/images/ic_arrow_gray.png';

  static String icGpsOrg = 'packages/life_module/assets/images/ic_gps_org.png';

  ///
  /// 转换定位数据
  /// [entity] 当前获取到的定位数据
  ///
  static Future<LocationEntity> convertLocation({LocationEntity? entity,String? location}) async{
    dynamic idata = await AMapRepository.get().geocodeAddress(key: Res.aWebMapKey, location: location);
    if(idata['status'] == '1' && idata['regeocode'] != null){
      if(idata['regeocode'] != null){
        idata = idata['regeocode'];
        entity!.address = idata['formatted_address'];
        if(idata['addressComponent'] != null){
          idata = idata['addressComponent'];
          entity.city = idata['city'];
          entity.aoiName = entity.address;
          entity.poiName = entity.address;
        }
      }
    }
    return Future.value(entity);
  }
}
