import 'package:common_module/utils/store_utils.dart';

class SearchHistoryUtils {
  static SearchHistoryUtils? _instance;
  static SearchHistoryUtils? getInstance() {
    if (_instance == null) {
      _instance = new SearchHistoryUtils();
    }
    return _instance;
  }

  String key = "__SearchHistoryUtils__";

  void push(String s) {
    if (s == null || s.isEmpty) {
      return;
    }
    var words = StoreUtils.getInstance()!.getForKey(
      key: key,
      defaultValue:[]
    );
    words = List<String>.from(words);
    words.insert(0, s);
    Set<String> uniWordes = words.toSet();

    words = uniWordes.toList();
    if (words.length > 20) {
      words = words.sublist(0, 20);
    }
    StoreUtils.getInstance()!.setKV(key: key, value: words);
  }

  List<String> getWords() {
    var words = StoreUtils.getInstance()!.getForKey(
      key: key,
    );
    if (words == null) {
      return [];
    }
    return List<String>.from(words);
  }

  void clear() {
    StoreUtils.getInstance()!.setKV(key: key, value: []);
  }
}
