import 'package:flutter/material.dart';
import 'package:flutter_boost/boost_navigator.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_module/components/life_image.dart';

class BuyLoadingDialogUtils {
  static BuyLoadingDialogUtils? _instance;

  static BuyLoadingDialogUtils? getInstance() {
    if (_instance == null) {
      _instance = new BuyLoadingDialogUtils._();
    }
    return _instance;
  }

  BuyLoadingDialogUtils._();

  LoadingDialog show() {
    return LoadingDialog();
  }
}

class LoadingDialog {
  Route? route;
  LoadingDialog() {
    route = _LoadingDialogRouter(_LoadingDialog());
    BoostNavigator.instance.appState!.topContainer!.navigator!.push(route!);
  }
  void close() {
    if (route != null && route!.navigator != null) {
      route!.navigator!.pop(route);
    }
  }
}

// loading widget
class _LoadingDialog extends Dialog {
  const _LoadingDialog()
      : super(
          clipBehavior: Clip.none,
        );

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      child: Material(
        type: MaterialType.transparency,
        child: Center(
          child: Container(
            width: 120.rpx,
            height: 120.rpx,
            decoration: BoxDecoration(
              color: rgba(0, 0, 0, 0.6),
              borderRadius: BorderRadius.circular(8),
            ),
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.center,
              children: <Widget>[
                Padding(
                  padding: EdgeInsets.only(top: 22.rpx, bottom: 10.rpx),
                  child: Container(
                    width: 30.rpx,
                    height: 30.rpx,
                    child: LifeImage(
                      name: "assets/images/shop/loading_icon.png",
                      width: 30.rpx,
                      height: 30.rpx,
                    ),
                  ),
                ),
                Padding(
                  padding: EdgeInsets.only(left: 8.rpx, right: 8.rpx),
                  child: Container(
                    child: Text(
                      "吃喝玩乐前先来小熊领优惠",
                      textAlign: TextAlign.center,
                      style: TextStyle(
                          color: Colors.white,
                          fontSize: 13.rpx,
                          height: 1.2.rpx),
                      overflow: TextOverflow.clip,
                    ),
                  ),
                )
              ],
            ),
          ),
        ),
      ),
      onWillPop: () async {
        return false;
      },
    );
  }
}

// loading路由
class _LoadingDialogRouter extends PageRouteBuilder {
  final Widget page;

  _LoadingDialogRouter(this.page)
      : super(
          opaque: false,
          barrierColor: Color(0x00000001),
          pageBuilder: (context, animation, secondaryAnimation) => page,
          transitionsBuilder: (context, animation, secondaryAnimation, child) =>
              child,
        );
}
