import 'package:flutter/material.dart';
import 'package:life_module/components/filter_panel.dart';
import 'package:life_repository/life_repository.dart';
import 'package:life_module/models/filter_model.dart';

class FilterPanelUtils {
  static OverlayEntry? overlayEntry;
  static show({
    required BuildContext context,
    required FilterModel model,
    required List<FilterItemEntity> items,
    required String? oneCheckedId,
    Function()? onChange,
    double? topOffset,
    String? twoCheckedId,
    Function()? onClose,
    Function(FilterItemEntity onwItem, FilterItemEntity twoItem)? onConfirm,
  }) {
    close();
    OverlayState overlayState = Overlay.of(context)!;

    overlayEntry = new OverlayEntry(builder: (context) {
      return FilterPanel(
        model: model,
        items: items,
        topOffset: topOffset,
        oneCheckedId: oneCheckedId,
        twoCheckedId: twoCheckedId,
        onClose: () {
          close();
          onClose!();
        },
        onConfirm: (onwItem, twoItem) {
          close();
          onConfirm!(onwItem!, twoItem!);
        },
        onChange:onChange,
      );
    });
    overlayState.insert(overlayEntry!);
  }

  static void close() {
    if (overlayEntry != null) {
      overlayEntry!.remove();
      overlayEntry = null;
    }
  }
}
