import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import '../models/mini_banner_model.dart';
import 'package:mvp/mvp.dart';
import 'package:common_module/widget/xiaoxiong_base_image_widget/widget.dart';
import 'package:life_module/utils/activity_config_tap_utils.dart';

// assets/close_btn_black.png
class FloatBanner extends StatelessWidget {
  final MiniBannerModel? model;
  FloatBanner({this.model});
  @override
  Widget build(BuildContext context) {
    return QMProvider<MiniBannerModel>.value(
      model: model!,
      builderWidget: (context, model, child) {
        if (model.getFloatBannerEntity() == null) {
          return SizedBox();
        }
        return Container(
          height: 96.rpx,
          width: 96.rpx,
          child: Stack(
            alignment: Alignment.topRight,
            children: [
              Positioned(
                  right: 0,
                  top: 10.rpx,
                  child: InkWell(
                      onTap: () {
                        AppTapConfigUtils.getInstance()!.activityConfigTap(model.getFloatBannerEntity()!.toJson());
                        model.removeFloatBannerEntity(true);
                      },
                      child: Container(
                        height: 76.rpx,
                        width: 76.rpx,
                        //padding: EdgeInsets.symmetric(horizontal: 9.rpx),
                        margin: EdgeInsets.only(top: 6.rpx, bottom: 6.rpx),
                        child: XiaoxiongBaseImageWidget(
                          imageUrl: model.getFloatBannerEntity()!.imgUrl!,
                          height: 76.rpx,
                          fit: BoxFit.contain,
                          placeholder:(BuildContext context, String data){
                            return Container();
                          },
                        ),
                      ))),
              InkWell(
                onTap: () {
                  model.removeFloatBannerEntity();
                },
                child: Container(
                    height: 16.rpx,
                    alignment: Alignment.topRight,
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(10.rpx),
                    ),
                    child: Image.asset(
                      "assets/close_btn_black.png",
                      width: 16.rpx,
                      height: 16.rpx,
                    )),
              )
            ],
          ),
        );
      },
    );
  }
}
