import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import '../models/mini_banner_model.dart';
import 'package:mvp/mvp.dart';
import 'package:common_module/widget/xiaoxiong_base_image_widget/widget.dart';
import 'package:life_module/utils/activity_config_tap_utils.dart';

class MiniBanner extends StatelessWidget {
  final MiniBannerModel? model;
  MiniBanner({this.model});
  @override
  Widget build(BuildContext context) {
    return SliverToBoxAdapter(
      child: QMProvider<MiniBannerModel>.value(
        model: model!,
        builderWidget: (context, model, child) {
          if (model.getList().length == 0) {
            return SizedBox();
          }
          // ;
          List<Widget> items = model.getList().map((e) {
            return Expanded(
              child: InkWell(
                onTap: () {
                  AppTapConfigUtils.getInstance()!.activityConfigTap(e.toJson());
                },
                child: Container(
                  padding: EdgeInsets.symmetric(horizontal: 4.rpx),
                  child: ClipRRect(
                      borderRadius: BorderRadius.circular(8.rpx),
                      child: Container(
                        height: 50.rpx,
                        child: XiaoxiongBaseImageWidget(
                          imageUrl: e.imgUrl!,
                          height: 50.rpx,
                          fit: BoxFit.cover,
                        ),
                      )),
                ),
              ),
            );
          }).toList();
          return Container(
            height: 56.rpx,
            padding: EdgeInsets.symmetric(horizontal: 9.rpx),
            margin: EdgeInsets.only(top: 8.rpx, bottom: 6.rpx),
            child: Row(
              children: items,
            ),
          );
        },
      ),
    );
  }
}
