import 'package:mvp/mvp.dart';
import 'package:life_repository/life_repository.dart';
import 'package:common_module/utils/store_utils.dart';
import 'package:common_module/utils/date_time_helper.dart';

const String _SHOP_KEY_ = "__life_float_banner__";

class MiniBannerModel extends BaseModel {
  List<ActivityConfigEntity> _list = [];
  ActivityConfigEntity? floatBanner;

  Future<void> getActivityConfigList() async {
    _list = await AppNavRepository.get().getActivityConfigList("20");
    List<ActivityConfigEntity> floats =
        await AppNavRepository.get().getActivityConfigList("22");
    if (floats.length > 0) {
      floatBanner = floats[0];
    }
    notifyListeners();
  }

  List<ActivityConfigEntity> getList() {
    return _list;
  }

  ActivityConfigEntity? getFloatBannerEntity() {
    if (floatBanner != null) {
      String? type = floatBanner!.showType;
      if (type != '2') {
        String? dateStr = StoreUtils.getInstance()!
            .getForKey(key: "$_SHOP_KEY_${floatBanner!.id}");
        if (type == '1' && dateStr != null) {
          return null;
        }
        String nowDateStr =
            DateUtil.formatDate(DateTime.now(), format: "yyyyMMdd");
        if (type == '3' && dateStr == nowDateStr) {
          return null;
        }
      }
    }
    return floatBanner;
  }

  void removeFloatBannerEntity([bool show = false]) {
    if (floatBanner != null) {
      String nowDateStr =
          DateUtil.formatDate(DateTime.now(), format: "yyyyMMdd");
      StoreUtils.getInstance()!
          .setKV(key: "$_SHOP_KEY_${floatBanner!.id}", value: nowDateStr);
      if (!show) {
        floatBanner = null;
        notifyListeners();
      }
    }
  }
}
