import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_module/components/life_image.dart';
import '../../../util/search_history_utils.dart';

class SearchHistory extends StatefulWidget {
  final Function(String)? onTap;
  SearchHistory({this.onTap});
  @override
  State<StatefulWidget> createState() => SearchHistoryState();
}

class SearchHistoryState extends State<SearchHistory> {
  Function(String)? get onTap => widget.onTap;
  List<String> words = [];
  @override
  void initState() {
    super.initState();
    words = SearchHistoryUtils.getInstance()!.getWords();
  }

  @override
  Widget build(BuildContext context) {
    if (words.length == 0) {
      return Container();
    }
    List<Widget> items = words.map((e) {
      String text = e;
      if (text.length > 5) {
        text = "${text.substring(0, 5)}...";
      }
      return InkWell(
        child: Container(
          decoration: BoxDecoration(
              color: rgba(248, 248, 247, 1),
              borderRadius: BorderRadius.circular(14.rpx)),
          padding: EdgeInsets.symmetric(horizontal: 12.rpx, vertical: 6.rpx),
          child: Text(
            text,
            style: TextStyle(
                color: rgba(102, 102, 102, 1), fontSize: 12.rpx, height: 1.rpx),
          ),
        ),
        onTap: () {
          onTap!(e);
        },
      );
    }).toList();
    return Container(
      color: Colors.white,
      padding: EdgeInsets.symmetric(horizontal: 13.rpx),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          SizedBox(
            height: 24.rpx,
          ),
          Container(
            height: 21.rpx,
            child: Row(
              children: [
                Container(
                  height: 21.rpx,
                  child: Text(
                    "搜索历史",
                    style: TextStyle(
                        color: rgba(51, 51, 51, 1),
                        fontSize: 15.rpx,
                        fontWeight: FontWeight.bold),
                  ),
                ),
                Spacer(),
                InkWell(
                  onTap: () {
                    setState(() {
                      words = [];
                    });
                    SearchHistoryUtils.getInstance()!.clear();
                  },
                  child: Container(
                    height: 21.rpx,
                    child: Row(
                      children: [
                        LifeImage(
                          name: "assets/images/ic_clear.png",
                          width: 18.rpx,
                          height: 18.rpx,
                        ),
                        Text(
                          "清除",
                          style: TextStyle(
                            color: rgba(153, 153, 153, 1),
                            fontSize: 13.rpx,
                          ),
                        )
                      ],
                    ),
                  ),
                )
              ],
            ),
          ),
          SizedBox(
            height: 12.rpx,
          ),
          Expanded(
            child: Container(
              child: SingleChildScrollView(
                child: Wrap(
                  spacing: 8.rpx,
                  runSpacing: 8.rpx,
                  crossAxisAlignment: WrapCrossAlignment.start,
                  children: items,
                ),
              ),
            ),
          )
        ],
      ),
    );
  }
}
