import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_repository/life_repository.dart';

class SearchTips extends StatelessWidget {
  final String? keywords;
  final List<SearchTipsItem>? items;
  final Function(SearchTipsItem)? onTap;
  SearchTips({this.items, this.keywords, this.onTap});
  @override
  Widget build(BuildContext context) {
    return Container(
      color: Colors.white,
      child: ListView.builder(
          padding: EdgeInsets.symmetric(horizontal: 13.rpx),
          itemCount: items!.length,
          itemBuilder: (context, index) {
            var item = items![index];
            List<String> names = item.name!.split("");
            List<TextSpan> childs = names.map((s) {
              bool isKeyWordChar = keywords!.indexOf(s) > -1;
              return TextSpan(
                  text: s,
                  style: TextStyle(
                      color: isKeyWordChar
                          ? rgba(255, 128, 0, 1)
                          : rgba(48, 38, 0, 1)));
            }).toList();
            return InkWell(
              child: Container(
                height: 40.rpx,
                alignment: Alignment.centerLeft,
                decoration: BoxDecoration(
                    border: Border(
                        bottom: BorderSide(
                            color: rgba(151, 151, 151, 0.2), width: 0.5.rpx))),
                child: Text.rich(
                  TextSpan(children: childs),
                  style: TextStyle(fontSize: 13.rpx),
                ),
              ),
              onTap: () {
                onTap!(item);
              },
            );
          }),
    );
  }
}
