import 'package:mvp/mvp.dart';
import 'dart:async';
import 'package:life_repository/life_repository.dart';

class Model extends BaseModel {
  String? _cityId = '';
  String? _latitude = '';
  String? _longitude = '';
  String keywords = '';
  String? _cityName;
  Timer? _searchTipsTimer;

  List<SearchTipsItem> _searchTipsList = [];

  Model(this._cityId, this._latitude, this._longitude, this._cityName);
  String? getCityId() {
    return _cityId;
  }

  String? getLatitude() {
    return _latitude;
  }

  String? getLongitude() {
    return _longitude;
  }

  void findSearchTips(String? firstCateId, String words) {
    keywords = words;
    if (keywords.isEmpty) {
      clearSearchTipsList();
    }
    if (_searchTipsTimer != null && _searchTipsTimer!.isActive) {
      _searchTipsTimer!.cancel();
      _searchTipsTimer = null;
    }

    _searchTipsTimer =
        Timer.periodic(Duration(milliseconds: 500), (timer) async {
      _searchTipsTimer!.cancel();
      _searchTipsTimer = null;
      List<SearchTipsItem> list = await FilterArepository.get().findSearchTips(
          _cityId!, _latitude!, _longitude!, firstCateId!, keywords);
      if (keywords != null && keywords.isNotEmpty) {
        _searchTipsList = list;
        notifyListeners();
      }
    });
  }

  List<SearchTipsItem> getSearchTipsList() {
    return _searchTipsList;
  }

  void clearSearchTipsList() {
    keywords = '';
    _searchTipsList = [];
    notifyListeners();
  }

  String getKeywords() {
    return keywords;
  }

  String? getCityName() {
    return _cityName;
  }
}
