import 'package:mvp/mvp.dart';
import '../models/sec_kill_model.dart';
import '../models/model.dart';
import '../models/banner_model.dart';

class IAction extends BaseAction<Model> {
  String? _cityId;
  String? _showId;
  String? _lat;
  String? _lng;
  String? _cityName;

  SecKillModel? _killModel;
  BannerModel? _bannerModel;

  IAction(this._cityId, this._showId, this._lat, this._lng, this._cityName);

  @override
  void initState() {
    _killModel = SecKillModel(_cityId, _showId, _lat, _lng);
    _bannerModel = BannerModel();
    setModel(Model());
    init();
  }

  void init() async {
    await getModel()!.findSeckillSession(_cityId!);
    if (_showId == null || _showId!.isEmpty) {
      _showId = getModel()!.getSeckillSessionList()[0].id;
    }
    getSecKillModel()!.setShowId(_showId);
    getSecKillModel()!.setCityId(_cityId);
    getSecKillModel()!.setLat(_lat);
    getSecKillModel()!.setLng(_lng);
    refresh();
    getModel()!.findPermission();
  }

  void refresh() async {
    await getBannerModel()!.getActivityConfigList();
    await getSecKillModel()!.refresh();
  }

  void setShowId(String id) {
    _showId = id;
    getSecKillModel()!.setShowId(id);
    getSecKillModel()!.clear();
    getSecKillModel()!.refresh();
  }

  void setLocaltionInfo(String? cityId, String lat, String lng) {
    _cityId = cityId;
    _lat = lat;
    _lng = lng;
    _showId = null;
    getSecKillModel()!.clear();
    getModel()!.getSeckillSessionList().clear();
    getModel()!.notifyListeners();
    init();
  }

  String? getCityName() {
    return _cityName;
  }

  SecKillModel? getSecKillModel() {
    return _killModel;
  }

  BannerModel? getBannerModel() {
    return _bannerModel;
  }
}
