import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_repository/life_repository.dart';
import '../actions/action.dart';
import 'package:mvp/mvp.dart';
import '../models/sec_kill_model.dart';

class Times extends StatefulWidget {
  final IAction? iAction;
  final List<SeckillSession>? times;
  final Function(String? tid)? onChange;
  Times({this.iAction, this.times, this.onChange});
  @override
  State<StatefulWidget> createState() => _TimesState();
}

class _TimesState extends State<Times> {
  ScrollController controller = ScrollController();
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return QMProvider<SecKillModel>.value(
      model: widget.iAction!.getSecKillModel()!,
      builderWidget: (context, module, child) {
        return Container(
          height: 64.rpx,
          padding: EdgeInsets.only(bottom: 8.rpx),
          color: rgba(245, 245, 245, 1),
          child: ListView.builder(
            physics: ClampingScrollPhysics(),
            controller: controller,
            padding: EdgeInsets.symmetric(horizontal: 9.rpx),
            scrollDirection: Axis.horizontal,
            itemBuilder: (context, i) {
              var item = widget.times![i];
              Color timeColor = rgba(48, 38, 0, 1);
              Color statusColor = rgba(102, 102, 102, 1);
              double timeSize = 20.rpx;

              List<String> timeArr = item.text!.split("-");

              String? timeText = timeArr[0];
              String statusText = item.statusText!;
              bool isSelected =
                  widget.iAction!.getSecKillModel()!.getShowId() == item.id;
              if (isSelected) {
                timeColor = Colors.white;
                statusColor = Colors.white;
                timeSize = 15.rpx;
                timeText = item.text;

                Future.delayed(Duration(milliseconds: 300)).then((value) {
                  Size size = MediaQuery.of(context).size;
                  controller.animateTo(
                      (108.rpx * i - size.width / 2 + 54.rpx).toDouble(),
                      duration: Duration(milliseconds: 300),
                      curve: Curves.linear);
                });
              }

              return InkWell(
                onTap: () {
                  if (widget.iAction!.getSecKillModel()!.getShowId() == item.id) {
                    return;
                  }
                  if (widget.iAction!.getSecKillModel()!.viewState !=
                      ViewState.idle) {
                    return;
                  }

                  widget.onChange!(item.id);
                },
                child: Container(
                  width: 100.rpx,
                  height: 56.rpx,
                  margin: EdgeInsets.symmetric(horizontal: 4.rpx),
                  decoration: BoxDecoration(
                      color: Colors.white,
                      gradient: isSelected
                          ? LinearGradient(
                              begin: Alignment.topCenter,
                              end: Alignment.bottomCenter,
                              colors: [
                                  rgba(255, 128, 0, 1),
                                  rgba(255, 4, 0, 1)
                                ])
                          : null,
                      borderRadius: BorderRadius.circular(8.rpx)),
                  child: Column(
                    children: [
                      SizedBox(
                        height: 10.rpx,
                      ),
                      Container(
                        height: 18.rpx,
                        child: Text(
                          timeText!,
                          style: TextStyle(
                              color: timeColor,
                              fontSize: timeSize,
                              height: 1.rpx,
                              fontWeight: FontWeight.bold),
                        ),
                      ),
                      SizedBox(
                        height: 6.rpx,
                      ),
                      Container(
                        child: Text(
                          statusText,
                          style: TextStyle(
                              color: statusColor,
                              fontSize: 12.rpx,
                              height: 1.rpx),
                        ),
                      )
                    ],
                  ),
                ),
              );
            },
            itemCount: widget.times!.length,
          ),
        );
      },
    );
  }
}
