import 'package:flutter/material.dart';
import 'package:common_module/components/i_app_bar.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_module/components/life_image.dart';
import 'package:life_module/views/sec_kill/models/model.dart';
import './components/times.dart';
import './components/ad_banner.dart';
import './components/localtion_tips.dart';
import './components/goods_items.dart';
import 'package:mvp/providers/provider.dart';
import './actions/action.dart';
import 'package:common_module/widget/pull_widget/widget.dart';
import 'package:flutter/cupertino.dart';

class LifeSecKillPage extends StatefulWidget {
  final Map<String, dynamic>? param;
  LifeSecKillPage({this.param});
  @override
  State<StatefulWidget> createState() => _LifeSecKillPageState();
}

class _LifeSecKillPageState extends State<LifeSecKillPage> {
  String? get tid => widget.param!['tid'];

  IAction? iAction;
  @override
  void initState() {
    super.initState();
    iAction = IAction(widget.param!['cityId'], tid, widget.param!['lat'],
        widget.param!['lng'], widget.param!['cityName']);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: rgba(245, 245, 245, 1),
      appBar: IAppBar(
        elevation: 0,
        color: rgba(245, 245, 245, 1),
        child: Container(
          alignment: Alignment.centerLeft,
          padding: EdgeInsets.only(left: 45.rpx),
          child: LifeImage(
            name: 'assets/images/life/ic_miaosha.png',
            width: 100.rpx,
            height: 24.rpx,
          ),
        ),
      ),
      body: ActionProvider<Model,IAction>(
          action: iAction!,
          builder: (context, child) {
            if (iAction!.getModel()!.getSeckillSessionList().length == 0) {
              return Container(
                alignment: Alignment.center,
                child: CupertinoActivityIndicator(radius: 10.rpx),
              );
            }
            return Column(
              children: [
                Times(
                  iAction: iAction,
                  times: iAction!.getModel()!.getSeckillSessionList(),
                  onChange: (tid) {
                    iAction!.setShowId(tid!);
                  },
                ),
                Expanded(
                    child: Container(
                        child: PullWidget(
                  controller: iAction!.getSecKillModel()!.getRefreshController(),
                  onLoad: () {
                    iAction!.getSecKillModel()!.getData();
                  },
                  onRefresh: () {
                    iAction!.refresh();
                  },
                  child: CustomScrollView(
                    slivers: [
                      AdBanner(iAction!.getBannerModel()),
                      LocaltionTips(
                        model: iAction!.getModel(),
                        onLocationChange: (cityId, lat, lon) {
                          iAction!.setLocaltionInfo(cityId, lat, lon);
                        },
                      ),
                      SliverToBoxAdapter(
                        child: Container(
                          height: 8.rpx,
                        ),
                      ),
                      GoodsItems(iAction),
                    ],
                  ),
                )))
              ],
            );
          }),
    );
  }
}
