import 'package:mvp/mvp.dart';
import '../models/model.dart';
import '../models/outer_info_model.dart';

class IAction extends BaseAction<Model> {
  String? shopId;
  String? lat;
  String? lng;
  String? firstCateId;
  String? itemId;
  final String? _cityName;
  OuterInfoModel? _outerInfoModel;

  Function()? load;

  IAction(this.shopId, this.lat, this.lng, this.firstCateId, this.itemId,
      this._cityName);
  @override
  void initState() {
    setModel(Model(shopId, lat, lng, this._cityName,itemId));
    _outerInfoModel = OuterInfoModel(shopId, firstCateId);
    init();
  }

  void init() async {
    await getModel()!.findShopDetail();
    await getOuterInfoModel()!.findShopOuterInfo();
    if (load != null) {
      load!();
    }
  }

  void onLoad(Function() cb) {
    load = cb;
  }

  String? getFirstCateId() {
    return firstCateId;
  }

  OuterInfoModel? getOuterInfoModel() {
    return _outerInfoModel;
  }
}
