import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_module/components/appraise_item.dart';
import 'package:life_module/views/shop/models/outer_info_model.dart';
import 'package:mvp/mvp.dart';
import 'package:flutter/cupertino.dart';

class AppraiseItems extends StatelessWidget {
  final OuterInfoModel? model;
  AppraiseItems(this.model);
  @override
  Widget build(BuildContext context) {
    return QMProvider<OuterInfoModel>.value(
      model: model!,
      builderWidget: (context, model, child) {
        if (model.getShopOuterInfoEntity() == null) {
          return SliverToBoxAdapter(
              child: Container(
            alignment: Alignment.center,
            color: Colors.white,
            child: CupertinoActivityIndicator(
              radius: 12,
            ),
          ));
        }

        var list = model.getShopOuterInfoEntity()!.commentItemEntitys;
        if (list.length == 0) {
          return SliverToBoxAdapter(
              child: Container(
            alignment: Alignment.center,
            padding: EdgeInsets.only(bottom: 15.rpx,top: 10.rpx),
            decoration: BoxDecoration(
                color: Colors.white,
                borderRadius:
                    BorderRadius.vertical(bottom: Radius.circular(8.rpx))),
            child: Text(
              "暂无评价",
              style: TextStyle(color: Colors.black87, fontSize: 12.rpx),
            ),
          ));
        }
        return SliverList(
            delegate: SliverChildBuilderDelegate(
          (BuildContext context, int index) {
            bool isLast = index == list.length - 1;
            return Column(
              children: [
                ClipRRect(
                  borderRadius:
                      isLast ? BorderRadius.circular(8.rpx) : BorderRadius.zero,
                  child: AppraiseItem(list[index]),
                ),
                isLast
                    ? SizedBox()
                    : Container(
                        height: 0.5.rpx,
                        padding: EdgeInsets.symmetric(horizontal: 12.rpx),
                        child: Container(
                          color: rgba(151, 151, 151, 0.1),
                        ),
                      )
              ],
            );
          },
          childCount: list.length,
        ));
      },
    );
  }
}
