import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:navigation_bar/navigation_bar.dart';
import 'package:life_module/components/persistent_header_delegate.dart';

class NavBar extends StatelessWidget {
  final TabController? controller;
  final Function(int)? onChange;
  NavBar({this.controller, this.onChange});
  @override
  Widget build(BuildContext context) {
    return SliverPersistentHeader(
      pinned: true,
      delegate: PersistentHeaderDelegate(
          minHeight: 60.rpx,
          maxHeight: 60.rpx,
          child: Container(
            height: 60.rpx,
            color: rgba(245, 245, 245, 1),
            padding: EdgeInsets.symmetric(vertical: 16.rpx),
            child: Container(
              height: 28.rpx,
              child: Row(
                children: [
                  Expanded(
                    child: Container(
                      child: NavigationBar(
                        controller: controller,
                        items: ["优惠", "推荐","评价"],
                        selectColor: rgba(255, 128, 0, 1),
                        normalColor: rgba(48, 38, 0, 1),
                        selectStyle: TextStyle(
                            fontWeight: FontWeight.bold,
                            fontSize: 16.rpx,
                            height: 1),
                        normalStyle: TextStyle(
                          fontWeight: FontWeight.bold,
                          fontSize: 16.rpx,
                          height: 1,
                        ),
                        isScrollable: true,
                        indicatorSize: TabBarIndicatorSize.label,
                        onTap: onChange,
                        indicator: RoundRectIndicator(
                            round: 14.rpx,
                            color: rgba(255, 128, 0, 1),
                            height: 2.rpx,
                            marginBottom: 0),
                      ),
                    ),
                  ),
                  Container(
                    child: Text(
                      "到店订单次日查看",
                      style: TextStyle(
                          color: rgba(255, 128, 0, 1), fontSize: 12.rpx),
                    ),
                  )
                ],
              ),
            ),
          )),
    );
  }
}
