import 'package:flutter/material.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_module/views/shop/models/outer_info_model.dart';
import 'package:mvp/mvp.dart';
import 'package:common_module/widget/xiaoxiong_base_image_widget/widget.dart';
import 'package:flutter/cupertino.dart';
import 'package:common_module/utils/image_preview_utils.dart';

class Recommend extends StatelessWidget {
  final OuterInfoModel? model;
  Recommend(this.model);
  @override
  Widget build(BuildContext context) {
    return SliverToBoxAdapter(
        child: Container(
      height: 132.rpx,
      padding: EdgeInsets.symmetric(vertical: 16.rpx, horizontal: 6.rpx),
      decoration: BoxDecoration(
          color: Colors.white,
          borderRadius: BorderRadius.vertical(bottom: Radius.circular(8.rpx))),
      child: QMProvider<OuterInfoModel>.value(
        model: model!,
        builderWidget: (context, model, child) {
          if (model.getShopOuterInfoEntity() == null) {
            return Container(
              alignment: Alignment.center,
              child: CupertinoActivityIndicator(
                radius: 12,
              ),
            );
          }
          if (model.getShopOuterInfoEntity()!.recommendItemEntitys.length == 0) {
            return Container(
              alignment: Alignment.center,
              padding: EdgeInsets.only(bottom: 15.rpx, top: 10.rpx),
              decoration: BoxDecoration(
                  color: Colors.white,
                  borderRadius:
                      BorderRadius.vertical(bottom: Radius.circular(8.rpx))),
              child: Text(
                "暂无推荐",
                style: TextStyle(color: Colors.black87, fontSize: 12.rpx),
              ),
            );
          }
          List<Widget> items =
              model.getShopOuterInfoEntity()!.recommendItemEntitys.map((e) {
            return Expanded(
              child: InkWell(
                onTap: () {
                  ImagePreviewUtils.showIndex(
                      context: context,
                      images: [e.itemPic!],
                      heroTag: e.itemPic);
                },
                child: Container(
                  padding: EdgeInsets.symmetric(horizontal: 6.rpx),
                  child: Column(
                    children: [
                      ClipRRect(
                          borderRadius: BorderRadius.circular(8.rpx),
                          child: Hero(
                            tag: e.itemPic!,
                            child: XiaoxiongBaseImageWidget(
                              height: 75.rpx,
                              width: 100.rpx,
                              imageUrl: e.itemPic!,
                              fit: BoxFit.cover,
                            ),
                          )),
                      SizedBox(
                        height: 8.rpx,
                      ),
                      Container(
                        height: 17.rpx,
                        alignment: Alignment.centerLeft,
                        child: Text(
                          e.itemTitle!,
                          style: TextStyle(
                              color: rgba(48, 38, 0, 1),
                              fontSize: 12.rpx,
                              fontWeight: FontWeight.bold),
                        ),
                      )
                    ],
                  ),
                ),
              ),
            );
          }).toList();
          return Row(
            children: items,
          );
        },
      ),
    ));
  }
}
