import 'dart:async';
import 'package:mvp/mvp.dart';
import 'package:life_repository/life_repository.dart';

class Model extends BaseModel {
  final String? _cityName;
  final String? _shopId;
  final String? _lat;
  final String? _lng;
  final String? _itemId;
  ShopInfoEntity? _shopInfoEntity;
  Model(this._shopId, this._lat, this._lng, this._cityName, this._itemId);

  Future<void> findShopDetail() async {
    var data =
        await (ShopInfoRepository.get().findShopDetail(_shopId!, _lat!, _lng!) as FutureOr<ShopInfoEntity>);
    var list = data.shopCouponItems;
    if (_itemId != null && _itemId!.isNotEmpty) {
      try {
        var index = list!.indexWhere((item) {
          return item.dealId == _itemId;
        });
        if (index > -1) {
          var item = list.removeAt(index);
          list.insert(0, item);
        }
      } catch (e) {}
    }
    _shopInfoEntity = data;
    notifyListeners();
  }

  ShopInfoEntity? getShopInfoEntity() {
    return _shopInfoEntity;
  }

  String? getCityName() {
    return _cityName;
  }
}
