import 'package:common_module/utils/audit_mode_utils.dart';
import 'package:flutter/material.dart';
import 'package:common_module/components/i_app_bar.dart';
import 'package:common_module/utils/xapp_utils.dart';
import 'package:life_module/components/life_image.dart';
import './components/shop_info.dart';
import './components/nav_bar.dart';
import './components/item_bar.dart';
import './components/goods_items.dart';
import './components/recommend.dart';
import './components/footer_explain.dart';
import 'package:mvp/providers/provider.dart';
import './actions/action.dart';
import 'package:flutter/cupertino.dart';
import '../../utils/share_dialog_utils.dart';
import 'components/appraise_items.dart';

class LifeShopPage extends StatefulWidget {
  final Map<String, dynamic>? param;
  LifeShopPage({this.param});
  @override
  State<StatefulWidget> createState() => _LifeShopPageState();
}

class _LifeShopPageState extends State<LifeShopPage>
    with TickerProviderStateMixin {
  TabController? tabController;
  late IAction iAction;
  ScrollController controller = ScrollController();
  GlobalKey globalKey1 = GlobalKey();
  GlobalKey globalKey2 = GlobalKey();
  GlobalKey globalKey3 = GlobalKey();
  double? offset1;
  late double offset2;
  late double offset3;
  bool isTap = false;


  @override
  void initState() {
    super.initState();
    var param = widget.param!;
    iAction = IAction(param['shopId'], param['lat'], param['lng'],
        param['firstCateId'], param['itemId'], param['cityName']);
    iAction.onLoad(() {
      Future.delayed(Duration(milliseconds: 500)).then((value) {
        RenderBox renderBox1 = globalKey1.currentContext!.findRenderObject() as RenderBox;
        RenderBox renderBox2 = globalKey2.currentContext!.findRenderObject() as RenderBox;
        RenderBox renderBox3 = globalKey3.currentContext!.findRenderObject() as RenderBox;
        offset1 = renderBox1.localToGlobal(Offset(0, 0)).dy;
        offset2 = renderBox2.localToGlobal(Offset(0, 0)).dy;
        offset3 = renderBox3.localToGlobal(Offset(0, 0)).dy;
      });
    });
    tabController = TabController(length: 3, vsync: this);
    controller.addListener(() {
      if (isTap) {
        return;
      }
      var size = MediaQuery.of(context).padding;
      var offset = controller.offset + 104.rpx + size.top;
      if (offset >= offset3) {
        tabController!.animateTo(2);
      } else if (offset >= offset2) {
        tabController!.animateTo(1);
      } else {
        tabController!.animateTo(0);
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        backgroundColor: rgba(245, 245, 245, 1),
        appBar: IAppBar(
          title: "全部优惠",
          color: Colors.white,
          actions:AuditModeUtils.getInstance()!.isAuditMode()?null:[
            InkWell(
              child: Container(
                width: 54.rpx,
                padding: EdgeInsets.symmetric(horizontal: 14.rpx),
                child: LifeImage(
                  name: "assets/images/shop/ic_share_black.png",
                  width: 26.rpx,
                  height: 26.rpx,
                ),
              ),
              onTap: () {
                if (iAction.getModel()!.getShopInfoEntity() == null) {
                  return;
                }
                ShareDialogUtils.getInstance()!.show(
                    context: context,
                    firstCateId: iAction.getFirstCateId(),
                    shopInfo: iAction.getModel()!.getShopInfoEntity()!.shopInfo);
              },
            )
          ],
        ),
        body: ActionProvider(
            action: iAction,
            builder: (context, child) {
              if (iAction.getModel()!.getShopInfoEntity() == null) {
                return Container(
                  padding: EdgeInsets.only(top: 100.rpx),
                  alignment: Alignment.topCenter,
                  child: CupertinoActivityIndicator(
                    radius: 12,
                  ),
                );
              }
              return Container(
                padding: EdgeInsets.symmetric(horizontal: 13.rpx),
                child: CustomScrollView(
                  controller: controller,
                  slivers: [
                    ShopInfo(iAction.getModel()),
                    NavBar(
                      controller: tabController,
                      onChange: (index) async {
                        isTap = true;
                        if (index == 0) {
                          await Scrollable.ensureVisible(
                              globalKey1.currentContext!);
                        } else if (index == 1) {
                          await Scrollable.ensureVisible(
                              globalKey2.currentContext!);
                        } else if (index == 2) {
                          await Scrollable.ensureVisible(
                              globalKey3.currentContext!);
                        }
                        isTap = false;
                      },
                    ),
                    ItemBar(globalKey1, "优惠"),
                    GoodsItems(iAction.getModel()),
                    SliverToBoxAdapter(
                        child: SizedBox(
                      height: 8.rpx,
                    )),
                    ItemBar(globalKey2, "推荐"),
                    Recommend(iAction.getOuterInfoModel()),
                    SliverToBoxAdapter(
                        child: SizedBox(
                      height: 8.rpx,
                    )),
                    ItemBar(globalKey3, "评价"),
                    AppraiseItems(iAction.getOuterInfoModel()),
                    //AllAppraise(),
                    FooterExplain(),
                  ],
                ),
              );
            }));
  }
}
